#!/usr/bin/perl -w
# $Id: openvpn-watchdog.pl,v 1.2 2009/05/04 13:59:40 are Exp $
# Das benoetigte OpenVPN muss in /etc/default/openvpn in AUTOSTART stehen
# Es ist empfohlen das OpenVPN auf einem festen Device laufen zu lassen, z.B. tun9 statt tun.
# benoetigt perl-modules

use strict;
use warnings;

if ( time() < 1235036563 ) {
  system 'ntpdate-debian -b -u';
}

my @psout;
my @routes;
my $line;
my @OVPNAUTO;
my $OVPN;
my $OVPNDEV;
my $OVPNDEVOK;
my $OVPNSTATUS;
my $DEFGW;

open(my $ovpndefault, "<", "/etc/default/openvpn") || die "/etc/default/openvpn?";
while (<$ovpndefault>) {
  if ( m/^AUTOSTART=\"(.*)\"/ ) {
    @OVPNAUTO = split /[ \t]/,$1;
  }
}
close $ovpndefault;

if ( $#OVPNAUTO == -1 ) {
  die "No OpenVPN";
}

open(my $fh, "ps -ef |") || die "ps -ef?";
while (<$fh>) {
  push @psout, $_;
}
close $fh;

### Alle OpenVPN testen
foreach $OVPN (@OVPNAUTO) {

  $OVPNDEV="";
  open($fh, "/etc/openvpn/$OVPN.conf") || die "/etc/openvpn/$OVPN.conf?";
  while (<$fh>) {
    if ( m/^dev (t[^ ]*)/ ) {
      $OVPNDEV=$1;
      chomp $OVPNDEV;
    }
  }
  close $fh;
  if ($OVPNDEV =~ m/^$/) {
    die "/etc/openvpn/$OVPN.conf dev?";
  }

  $DEFGW=0;
  open($fh, "ip route ls|") || die "Route?";
  while (<$fh>) {
    push @routes, $_;
    if ( m/^default via / ) {
      $DEFGW=1;
    }
  }
  close $fh;
  if ($DEFGW==0) {
    print "DefaultGW?\n";
    system "/etc/init.d/networking restart";
    system 'ntpdate-debian -b -u';
    system '/etc/init.d/ntp restart';
  }

  ### Pruefen ob das OpenVPN Netzwerkdevice existiert
  $OVPNDEVOK=0;
  foreach $line (@routes) {
    if ( $line =~ /$OVPNDEV/ ) {
      $OVPNDEVOK=1;
    }
  }
  if ($OVPNDEVOK==0) {
    print "OpenVPN Dev?\n";
    system 'ntpdate-debian -b -u';
    system "/etc/init.d/openvpn restart $OVPN";
  }

  ### Pruefen ob das OpenVPN laeuft
  $OVPNSTATUS=0;
  foreach $line (@psout) {
    if ( $line =~ m/\/usr\/sbin\/openvpn .*--daemon ovpn-$OVPN / ) {
      $OVPNSTATUS=1;
    }
  }
  if ( $OVPNSTATUS!=1 ) {
    print "OpenVPN?\n";
    system 'ntpdate-debian -b -u';
    system "/etc/init.d/openvpn restart $OVPN";
  }

  
}

